
redis.replicate_commands()

-- time ./src/redis-cli --eval delete_expired_records.lua , 17 50000 10000 1496256206
-- Get values from arguments. Sequence :	expiry_age(in days), max_record_limit, min_record_limit, now/timeSinceEpoch

local expiry_age   = tonumber(ARGV[1])
local max_record_limit = tonumber(ARGV[2])
local min_record_limit    = tonumber(ARGV[3])
local now          = tonumber(ARGV[4])
expiry_age = expiry_age * 86400

local db_age  = tonumber(redis.call('GET','db_age'))
local db_size = tonumber(redis.call('DBSIZE')) - 1

-- gets all fields from a hash as a dictionary
local hgetall = function (key)
  local bulk = redis.call('HGETALL', key)
	local result = {}
	local nextkey
	for i, v in ipairs(bulk) do
		if i % 2 == 1 then
			nextkey = v
		else
			result[nextkey] = v
		end
	end
	return result
end

if ( ( db_size > max_record_limit ) and ( db_age < ( now - expiry_age ) ) ) then
	local new_age = now

	local cursor = "0"
	local count  = 0
	repeat
		local r = redis.call("SCAN", cursor, "MATCH", "*", "COUNT", 1000)
		cursor = r[1]
		local keys = r[2]

		for i = 1, #keys do
			-- Database have all keys in ip address format, expect key db_age
			if ( keys[i] ~= 'db_age') then
				-- local result = process(keys[i])
				local data = hgetall(keys[i])
				if ( tonumber(data['ls']) < ( now - expiry_age ) ) then
					redis.call('DEL',keys[i])
				elseif( tonumber(data['fso']) < now ) then
					new_age = tonumber(data['fso'])
				end
			end
		end
		count = count + #r[2]
	until cursor == "0"
		
	redis.call('SET','db_age', new_age)
	-- Get no of keys after deleting expired records
	db_size = tonumber(redis.call('DBSIZE')) - 1
	if( db_size < min_record_limit ) then
		if( db_size < 1 ) then
			redis.call('DEL','db_age')
		else
			redis.call('SET','db_age', now)
		end
	end
end
